import {getOneElementOrThrow} from "../libs/element.js";
import {getCurrentDir, navigate, onceNavigate} from "../libs/navigation.js";
import {sep} from "../libs/path.js";
import {getTemplate} from "../libs/template.js";

export const renderBreadcrumbs = () => {
    const breadcrumbsEl = getOneElementOrThrow(document, '[data-ui=breadcrumbs]');
    breadcrumbsEl.innerHTML = '';

    const currentDir = getCurrentDir();
    const currentDirSplit = currentDir.split(sep);

    currentDirSplit.map((value, index, array) => {
        if (value) {
            const restSplit = [...array].reverse().splice(array.length - (index + 1)).reverse();
            const path = restSplit.join(sep);

            const template = getTemplate('breadcrumbs');
            const actionEl = template.el('action');
            actionEl.innerText = value;
            actionEl.addEventListener('click', () => navigate(path));

            breadcrumbsEl.appendChild(template.render());
        }
    });

    onceNavigate(() => renderBreadcrumbs());
}